from .typing import MetaModels
from . import Providers


class Models(metaclass=MetaModels):
    class gpt_35_turbo:
        name: str = 'gpt-3.5-turbo'
        base_provider: str = 'openai'
        best_site: str = Providers.Ails

    class gpt_4:
        name: str = 'gpt-4'
        base_provider: str = 'openai'
        best_site: str = Providers.Phind


class ChatCompletion:
    @staticmethod
    def create(model, messages, provider=None, stream=False, **kwargs):
        try:
            engine = model.best_site if not provider else provider
            model_name = model.name if isinstance(model, Models) else model

            return (engine._create_completion(model_name, messages, **kwargs)
                    if stream else ''.join(engine._create_completion(model_name, messages, **kwargs)))
        except TypeError as e:
            arg = str(e).split("'")[1]
            raise ValueError(f"{engine.__name__} does not support '{arg}' argument") from e


# you.py